         SECTION H                                                      FILE EXTRA.H
                                      AND..... Finally!!
                                      ******************

               We have covered a lot of ground in these two discs, from raw
          beginnings to quite advanced concepts. There still remain two major fields
          in MALLARD BASIC which I have only touched upon superficially; Files and
          Machine Code, but I hope to cover these in the future.
               In my opinion, working with sequential, random access and keyed files
          (JETSAM) in BASIC is only justified in special circumstances, otherwise it
          is better to use a dedicated database program such as the one in Mini
          Office or one of the many others available for the PCW. To write a large
          database program which is versatile and foolproof would be time-consuming
          and difficult and rather like reinventing the wheel. However, some of the
          special circumstances mentioned above might be :-
               1) If it forms an integral part of the BASIC program, such as
          sequential files used to store input data from the keyboard which can be
          read back within the program for display on screen or printed out or both.
          (See file MORE.G)
               2) Writing  programs for use by other PCW users, who would certainly
          have MALLARD BASIC but may not have the software necessary to run programs
          written for other environments.
               3) Not least to try out the file handling facilities offered by
          MALLARD BASIC for your own pleasure and interest.

               On the other hand MACHINE CODE used selectively from within a MALLARD
          BASIC program is well worth doing and can greatly increase the speed of
          operation of such things as graphics and perform functions not possible
          with 'straight' BASIC. Such a program would take much less time to write
          than a complete Machine Code program written in Assembler, yet would
          perform almost as well. Also, anyone wanting to learn Assembler would be
          well advised to start this way; it is a first-class way to dip your toes in
          the water.
               One of the drawbacks in writing programs in an interpreted BASIC such
          as MALLARD is that it must be run in a MALLARD BASIC environment, unlike a
          compiled language which can produce .COM files which can be run directly
          from CP/M. Again, if you are thinking of writing programs for profit, the
          code is open for inspection and copying, although some security is afforded
          if the program is saved using the protective code 'p'  e.g SAVE "myprog",p
          Nevertheless, excellent programs are written in BASIC by professionals for
          sale. Some prefer it, and if you are writing for a particular machine, like
          the PCW, you know very well that your prospective customer will have
          MALLARD.
               There is a bug in some versions of MALLARD which allows one to
          unprotect programs. Why not try it with RPED.BAS which is protected.
               1) Enter "SAVE "dummy",a and press [RETURN]. This makes an empty file
               2) Load RPED.BAS and try to list it... No dice
               3) Enter "MERGE "dummy" and press [RETURN]
               4) Try the command LIST again. with any luck it should list out RPED
               5) SAVE under any suitable name e.g SAVE "rped1",a
               If you're successful, delete the word SYSTEM in line 19 and the
          program will not jump out of BASIC when you EXIT. RPED.BAS is an
          interesting program. See if you can discover how it works.
          TIMESAVING
          **********   There are usually several ways of achieving the same ends in
          computing, but a little forethought can often save a lot of time, just as
          an ill-considered action can waste a lot of time. Try to observe the
          following and you'll go farther, faster.

          General
               1.1) Don't switch your computer on or off or reset it with a disc in a
               drive, and don't remove or replace discs in a drive whilst the drive
               is running. Listen for the drive to stop first.Most times it'll be O.K
               but once in a while you'll corrupt the file index or files. When
               rebooting use [SHIFT]+[EXTRA]+[EXIT] to reset your machine; it's
               easier on the machine than switching off and on.
               1.2) Don't work with Master discs or your only copy of a file. It's
               easy to copy files with NSWP.COM. Don't be mean with discs; if you
               feel that 3" discs are too expensive, fit a 3.5" or 5.25 drive- these
               discs are much cheaper.
               1.3) Store your discs, especially Master discs carefully, away from
               heat and magnets. I keep my masters in a tin box to counteract
               possible magnetism.
               1.4) Keep potential disasters, like cups of coffee, away from your
               machine and discs.
               1.5) File your discs in a suitable box and index them carefully.
               Looking for a certain disc, or worse, a particular file, can be very
               time-consuming. I speak from experience.
               1.6) When leaving your machine running for some time, try to leave the
               screen blank to avoid 'burning' See 2.2) and 3.9)
          CP/M
               2.1) A command line can be reinstated by pressing [COPY]. Useful when
               using utilities like PIP and FIND. or if your command line is
               incorrect first time.
               2.2) The screen can be cleared by pressing [EXIT]+[E]
               2.3) Home the cursor with [EXTRA]+[H]
               2.4) The printer will copy anything that appears on screen after
               [ALT]+[P] (bleep) Use again to toggle off.
               2.5) [EXTRA]+[PTR] will print anything on screen at the time to a
               smaller scale(Screen dump). Invaluable at times!
               2.6) Make a Start-of Day disc, preferably Auto-loading, for any
               computing theme that you use regularly.
          BASIC
               3.1) A line can be reinstated by pressing the left cursor arrow.
               3.2) Go to end of line by pressing [FIND] twice
               3.3) Delete from cursor to end of line by pressing [CUT] twice
               3.4) Leave plenty of spaces between line numbers; tidy up with RENUM
               on completion
               3.5) Lines reinstated as 10) or with EDIT or AUTO can be renumbered
               and edited if necessary to save typing.
               3.6) Plan your program layout; put similar modules equal distances
               apart e.g, 200,300,400 or 1000,2000,3000 etc. to simplify use of AUTO
               for checking or editing.
               3.7) Save and use standard modules for initialisation, subroutines
               etc.
               3.8) Use the regular SAVEing routine for the first four lines as
               described several times elsewhere.
               3.9) Always make an early line cls$=chr$(27)+"E", then whenever
               required, typing 'print cls$'+[RETURN] will clear the screen. See
               1.6).
               3.10) Save work at the end of each session to more than one disc. Even
               the other side of an A: drive disc is some insurance against mishap,
               although a different disc is better.
               3.11) [ALT]+[ENTER] locks capitals but keeps numbers. Useful when
               filling DATA statements in Hexadecimal
               3.12) [ALT]+[RELAY] brings number pad into use.(9 keys on the
               right-hand side of the keyboard). Useful sometimes
               3.13) [+] toggles overstrike mode for editing. Cancels automatically
               on pressing [RETURN]. can save a lot of time after practice.
               3.14) Use auto to bring up matching lines such as menus to assist in
               standardising and lining up.

               Well, you can see from the above that there are many ways to save
          time, typing and trouble; the above notes could be added to and in time
          you'll have your own favourite time-savers. Time at the keyboard is often
          hard to find and anything that improves the situation is fine, so don't
          forget that planning, making notes and many other activities can be done at
          odd times during the day anywhere.
               The PCW is often slated in the computer press for being slow, but in
          general, more time is wasted by the operator than by the machine. If you
          want to do CADCAM or advanced graphics or colour you need a more powerful
          machine, but the PCW is an ideal machine for the small business, the home
          or the hobbyist. It is rugged and reliable, with wellproven technology and
          reasonably priced software. Much of the speed and memory of more powerful
          machines is squandered by software with 'bells and whistles' and way-out
          facilities which usually consume more time than they save. Stay with your
          PCW until you are absolutely sure that you need more power, then look
          carefully before you leap! In the meantime, try to organise your sessions.
          If you need a coffee, wait until you have set the printer going, preferably
          using continuous paper. If your machine is working on something and has
          locked you out, fill in the time by planning ahead, or by studying your
          manual.
               Finally, your PCW is a miracle of technology, a powerful machine that
          quite large business users would have given their eye teeth for a few years
          ago. If you finally find out everything that the machine can do, you will
          know more than the designers of the machine.
               Thank you for using BASTUTOR; I hope you have enjoyed it and will
          continue to use it as a reference work.

          End of file EXTRA.H
UTOR; I hope you have enjoyed it and will
          continue 